var buster = require("buster");
var assert = buster.assert;
var refute = buster.refute;
buster.coffeeProcessor = require("../../lib/buster-client/coffee-processor");

buster.testCase("Buster CoffeeScript pre-processor", {
    "should compile coffee resource and yield javascript": function (done) {
        buster.coffeeProcessor("/some/file.coffee", {
            content: "square = (x) -> x * x"
        }).then(function (path, resource) {
            assert.equals(path, "/some/file.js");
            assert.equals(resource.content, "(function() {\n" +
                          "  var square;\n" +
                          "  square = function(x) {\n" +
                          "    return x * x;\n" +
                          "  };\n" +
                          "}).call(this);\n");
            done();
        });
    },

    "should yield compilation error": function (done) {
        buster.coffeeProcessor("/some/file.coffee", {
            content: "square = (x -x * x"
        }).then(function () {}, function (err) {
            refute.isNull(err);
            assert.match(err.message, "Unclosed (");
            done();
        });
    },

    "should not attempt to process js files": function () {
        assert.isUndefined(buster.coffeeProcessor("/some/file.js", { content: "" }));
    }
});
