var buster = require("buster");
var assert = buster.assert;
var refute = buster.refute;
buster.kaffeineProcessor = require("../../lib/buster-client/kaffeine-processor");

buster.testCase("Buster Kaffeine pre-processor", {
    "should compile kaffeine resource and yield javascript": function (done) {
        buster.kaffeineProcessor("/some/file.k", {
            content: "square = { # * # }"
        }).then(function (path, resource) {
            assert.equals(path, "/some/file.js");
            assert.equals(resource.content, " var square; square = function() { return arguments[0] * arguments[0] }\n");
            done();
        });
    },


    "should yield compilation error": function (done) {
        buster.kaffeineProcessor("/some/file.k", {
            content: "square = # * # }"
        }).then(function () {}, function (err) {
            refute.isNull(err);
            assert.match(err.message, "Cannot set");
            done();
        });
    },

    "should not attempt to process js files": function () {
        assert.isUndefined(buster.kaffeineProcessor("/some/file.js", { content: "" }));
    }
});
